// RW Pandora Project
// ==================
// Modular robowaifu demo project

// Filename: ./main_pandora.cpp
// -The program's entry point

#include "incls_all.hpp"

void init_pandora(Pandora& pandora);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\n entering main()...");

  Pandora pandora{"Pandora"};
  init_pandora(pandora);

  puts(" ...leaving main()\n");

} catch (runtime_error const& e) {
  cerr << "\n  runtime_error '" << e.what() << "' caught in main()\n\n";

} catch (exception const& e) {
  cerr << "\n  exception '" << e.what() << "' caught in main()\n\n";

} catch (...) {
  cerr << "\n  unknown error caught in main()\n\n";
}

//------------------------------------------------------------------------------
/**
 */
void init_pandora(Pandora& pandora) {
  puts("");

  pandora.do_preflight();
  //
  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // DIAG:
  prt_tag(pandora.t());

  puts("");

  prt_tag(pandora.animeyes().t(), "pandora.animeyes()");
  prt_tag(pandora.atashi().t(), "pandora.atashi()");
  prt_tag(pandora.bones().t(), "pandora.bones()");
  prt_tag(pandora.curator().t(), "pandora.curator()");
  prt_tag(pandora.dollhouse().t(), "pandora.dollhouse()");
  prt_tag(pandora.electro().t(), "pandora.electro()");
  prt_tag(pandora.face().t(), "pandora.face()");
  prt_tag(pandora.gears().t(), "pandora.gears()");
  prt_tag(pandora.hand().t(), "pandora.hand()");
  prt_tag(pandora.hearsay().t(), "pandora.hearsay()");
  prt_tag(pandora.meido().t(), "pandora.meido()");
  prt_tag(pandora.shell().t(), "pandora.shell()");

  puts("");

  prt_tag(pandora.graphicom().t(), "pandora.graphicom()");

  puts("");
}

//    --=^=--

// "______"

// rw_pandora_demo.v220326
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
